<template>
  <b-container fluid>
    <b-button variant="primary" class="mb-2 mr-sm-2 mb-sm-2" @click="$router.go(-1)">Назад</b-button>
    <b-card>
      <button class="btn btn-primary" @click="openAddingModal">
        <i class="icon-plus"></i>
      </button>
      <b-list-group class="col-md-12">
        <b-list-group-item>Гос.номер машины: {{ logisticInfo.govNumber }}</b-list-group-item>
        <b-list-group-item>Дата выезда: {{ dateFormat(logisticInfo.date) }}</b-list-group-item>
        <b-list-group-item>Водитель: {{ logisticInfo.employee.lastName + ' ' + logisticInfo.employee.name }}</b-list-group-item>
        <b-list-group-item>Телефон: {{ logisticInfo.employee.phone }}</b-list-group-item>
      </b-list-group>
    </b-card>
    <b-card :header="caption">
      <div slot="header">Наличными</div>
      <div v-if="items.cashExcel">
        <download-excel
          class="btn btn-success pull-right"
          :data="birMassiv"
          :fields="jsonFields"
          name="cash.xls"
        >Скачать Excel11</download-excel>
      </div>
      <!-- <nav>
        <b-form-input v-model="filter" placeholder="Поиск..." />
      </nav>-->
      <b-form inline>
        <b-form-input
          class="mb-2 mr-sm-2 mb-sm-0 col-sm-4"
          v-model="selected.cash.text"
          placeholder="Поиск..."
        ></b-form-input>
        <b-form-select class="mb-2 mr-sm-2 mb-sm-0" v-model="selected.cash.type" :options="types"></b-form-select>
        <b-button
          variant="primary"
          class="mb-2 mr-sm-2 mb-sm-0"
          @click.prevent="filterCustom('cash')"
        >Показать</b-button>
      </b-form>
      <br>

      <b-table
        :hover="hover"
        :striped="striped"
        :bordered="bordered"
        :small="small"
        responsive
        :items="cash"
        :fields="fields"
        :current-page="currentPage"
        :per-page="perPage"
      >
        <template slot="number" slot-scope="data">{{(data.item.number).padStart(5, '0')}}</template>
        <template slot="provider" slot-scope="data">
          <div v-for="pro in data.item.provider">
            <div
              v-if="pro.id"
            >{{pro.id.lastName + ' ' + pro.id.name +', ' + pro.placeAmount + ', ' + pro.summ + '\n'}}</div>
          </div>
        </template>
        <template
          slot="contrAgent"
          slot-scope="data"
        >{{data.item.contrAgent.lastName + ' ' + data.item.contrAgent.name}}</template>
        <template slot="phone" slot-scope="data">{{data.item.contrAgent.phone}}</template>
        <template
          slot="payStatus"
          slot-scope="data"
        >{{data.item.payStatus === 'online' ? "Онлайн" : data.item.payStatus === 'cash' ? "Наличными" : data.item.payStatus === 'payed' ? "Оплачено" : "Нет данных"}}</template>
        <template slot="status" slot-scope="data">
          <div v-if="data.item.status === 'storage'">
            <b-badge variant="danger">На складе</b-badge>
          </div>
          <div v-else-if="data.item.status === 'ship'">
            <b-badge variant="warning">В дороге</b-badge>
          </div>
          <div v-else-if="data.item.status === 'done'">
            <b-badge variant="success">Доставлено</b-badge>
          </div>
          <div v-else-if="data.item.status === 'end'">
            <b-badge variant="success">Завершен</b-badge>
          </div>
        </template>
        <template slot="payed" slot-scope="data">
          <div v-if="data.item.payed">
            <b-badge variant="success">Доставлено</b-badge>
          </div>
          <div v-else>
            <b-badge variant="danger">Не доставлено</b-badge>
          </div>
        </template>
        <template slot="date" slot-scope="data">
          <div v-if="data.item.date">{{ dateFormat(data.item.date) }}</div>
        </template>
        <template slot="action" slot-scope="data">
          <b-button size="sm" @click.stop="info(data.item)" class="mr-1 tableActionbtn">
            <i class="icon-pencil"></i>
          </b-button>
        </template>
      </b-table>
      <nav>
        <b-pagination
          :total-rows="getRowCount(cash)"
          :per-page="perPage"
          v-model="currentPage"
          prev-text="Предыдущая"
          next-text="Следующая"
          hide-goto-end-buttons
        />
      </nav>
      <b-card :header="caption">
        <div slot="header">Итог</div>
        Общая сумма: {{totalCash}}
      </b-card>
    </b-card>

    <b-card :header="caption">
      <div slot="header">Онлайн</div>

      <!-- <nav>
        <b-form-input v-model="filter" placeholder="Поиск..." />
      </nav>-->
      <b-form inline>
        <b-form-input
          class="mb-2 mr-sm-2 mb-sm-0 col-sm-4"
          v-model="selected.online.text"
          placeholder="Поиск..."
        ></b-form-input>
        <b-form-select class="mb-2 mr-sm-2 mb-sm-0" v-model="selected.online.type" :options="types"></b-form-select>
        <b-button
          variant="primary"
          class="mb-2 mr-sm-2 mb-sm-0"
          @click.prevent="filterCustom('online')"
        >Показать</b-button>
      </b-form>
      <br>

      <b-table
        :hover="hover"
        :striped="striped"
        :bordered="bordered"
        :small="small"
        responsive
        :items="online"
        :fields="fields"
        :current-page="currentPage2"
        :per-page="perPage"
      >
        <template slot="number" slot-scope="data">{{(data.item.number).padStart(5, '0')}}</template>
        <template slot="provider" slot-scope="data">
          <div v-for="pro in data.item.provider">
            <div
              v-if="pro.id"
            >{{pro.id.name + ' ' + pro.id.lastName + ', ' + pro.placeAmount + ', ' + pro.summ + '\n'}}</div>
          </div>
        </template>
        <template
          slot="contrAgent"
          slot-scope="data"
        >{{data.item.contrAgent.lastName + ' ' + data.item.contrAgent.name}}</template>
        <template slot="phone" slot-scope="data">{{data.item.contrAgent.phone}}</template>
        <template
          slot="payStatus"
          slot-scope="data"
        >{{data.item.payStatus === 'online' ? "Онлайн" : data.item.payStatus === 'cash' ? "Наличными" : data.item.payStatus === 'payed' ? "Оплачено" : "Нет данных"}}</template>
        <template slot="status" slot-scope="data">
          <div v-if="data.item.status === 'storage'">
            <b-badge variant="danger">На складе</b-badge>
          </div>
          <div v-else-if="data.item.status === 'ship'">
            <b-badge variant="warning">В дороге</b-badge>
          </div>
          <div v-else-if="data.item.status === 'done'">
            <b-badge variant="success">Доставлено</b-badge>
          </div>
          <div v-else-if="data.item.status === 'end'">
            <b-badge variant="success">Завершен</b-badge>
          </div>
        </template>
        <template slot="payed" slot-scope="data">
          <div v-if="data.item.payed">
            <b-badge variant="success">Доставлено</b-badge>
          </div>
          <div v-else>
            <b-badge variant="danger">Не доставлено</b-badge>
          </div>
        </template>
        <template slot="date" slot-scope="data">
          <div v-if="data.item.date">{{ dateFormat(data.item.date) }}</div>
        </template>
        <template slot="action" slot-scope="data">
          <b-button size="sm" @click.stop="info(data.item)" class="mr-1 tableActionbtn">
            <i class="icon-pencil"></i>
          </b-button>
        </template>
      </b-table>
      <nav>
        <b-pagination
          :total-rows="getRowCount(online)"
          :per-page="perPage"
          v-model="currentPage2"
          prev-text="Предыдущая"
          next-text="Следующая"
          hide-goto-end-buttons
        />
      </nav>
      <b-card :header="caption">
        <div slot="header">Итог</div>
        Общая сумма: {{totalOnlineCash}}
      </b-card>
    </b-card>
    <b-card :header="caption">
      <div slot="header">Оплачено</div>

      <!-- <nav>
        <b-form-input v-model="filter" placeholder="Поиск..." />
      </nav>-->
      <b-form inline>
        <b-form-input
          class="mb-2 mr-sm-2 mb-sm-0 col-sm-4"
          v-model="selected.payed.text"
          placeholder="Поиск..."
        ></b-form-input>
        <b-form-select class="mb-2 mr-sm-2 mb-sm-0" v-model="selected.payed.type" :options="types"></b-form-select>
        <b-button
          variant="primary"
          class="mb-2 mr-sm-2 mb-sm-0"
          @click.prevent="filterCustom('payed')"
        >Показать</b-button>
      </b-form>
      <br>

      <b-table
        :hover="hover"
        :striped="striped"
        :bordered="bordered"
        :small="small"
        responsive
        :items="payed"
        :fields="fields"
        :current-page="currentPage3"
        :per-page="perPage"
      >
        <template slot="number" slot-scope="data">{{(data.item.number).padStart(5, '0')}}</template>
        <template slot="provider" slot-scope="data">
          <div v-for="pro in data.item.provider">
            <div
              v-if="pro.id"
            >{{pro.id.name + ' ' + pro.id.lastName + ', ' + pro.placeAmount + ', ' + pro.summ + '\n'}}</div>
          </div>
        </template>
        <template
          slot="contrAgent"
          slot-scope="data"
        >{{data.item.contrAgent.lastName + ' ' + data.item.contrAgent.name}}</template>
        <template slot="phone" slot-scope="data">{{data.item.contrAgent.phone}}</template>
        <template
          slot="payStatus"
          slot-scope="data"
        >{{data.item.payStatus === 'online' ? "Онлайн" : data.item.payStatus === 'cash' ? "Наличными" : data.item.payStatus === 'payed' ? "Оплачено" : "Нет данных"}}</template>
        <template slot="status" slot-scope="data">
          <div v-if="data.item.status === 'storage'">
            <b-badge variant="danger">На складе</b-badge>
          </div>
          <div v-else-if="data.item.status === 'ship'">
            <b-badge variant="warning">В дороге</b-badge>
          </div>
          <div v-else-if="data.item.status === 'done'">
            <b-badge variant="success">Доставлено</b-badge>
          </div>
          <div v-else-if="data.item.status === 'end'">
            <b-badge variant="success">Завершен</b-badge>
          </div>
        </template>
        <template slot="payed" slot-scope="data">
          <div v-if="data.item.payed">
            <b-badge variant="success">Доставлено</b-badge>
          </div>
          <div v-else>
            <b-badge variant="danger">Не доставлено</b-badge>
          </div>
        </template>
        <template slot="date" slot-scope="data">
          <div v-if="data.item.date">{{ dateFormat(data.item.date) }}</div>
        </template>
        <template slot="action" slot-scope="data">
          <b-button size="sm" @click.stop="info(data.item)" class="mr-1 tableActionbtn">
            <i class="icon-pencil"></i>
          </b-button>
        </template>
      </b-table>
      <nav>
        <b-pagination
          :total-rows="getRowCount(payed)"
          :per-page="perPage"
          v-model="currentPage3"
          prev-text="Предыдущая"
          next-text="Следующая"
          hide-goto-end-buttons
        />
      </nav>
      <b-card :header="caption">
        <div slot="header">Итог</div>
        Общая сумма: {{totalPayedCash}}
      </b-card>
    </b-card>

    <b-card :header="caption">
      <div slot="header">Итог</div>
      Общая сумма: {{totalSumm}}
    </b-card>

    <b-modal id="addingModal" @hide="resetModal" title="Добавление" centered @ok="adding" ok-only>
      <b-container fluid>
        <b-form-group>
          <label>Заказы</label>
          <b-form-select
            multiple
            :select-size="4"
            v-model="addedInfo.bid"
            :options="bids"
            class="modalInput"
          ></b-form-select>
        </b-form-group>
        <b-btn class="mt-3" variant="primary" :disabled="disabled" block @click="adding">Добавить</b-btn>
      </b-container>
      <div slot="modal-footer" class="w-100"></div>
    </b-modal>

    <b-modal id="modalInfo" @hide="resetModal" title="Редактирование" centered @ok="edit" ok-only>
      <b-container fluid>
        <!-- <p v-for="provider in providers">
          <label>Передал</label><br/>
          <b-form-select v-model="" :options="employees" class="col-10" size="sm"/>
          {{provider.id}}
          <hr />
        </p>-->
        <div v-for="(n, index) in modalInfo.provider">
          <b-form-group>
            <label>Передал *</label>
            <!-- <b-form-select :options="employees" v-model="modalInfo.provider[index].id._id" class="" size="sm"></b-form-select> -->
            <Multiselect
              name="provider2"
              placeholder="Выберите"
              v-validate="'required'"
              v-model="modalInfo.provider[index].id"
              :options="employees"
              track-by="id"
              label="fullname"
            ></Multiselect>
            <span
              v-show="errors.has('provider2')"
              class="text-danger"
            >{{ errors.first('provider2') }}</span>
          </b-form-group>
          <b-form-group>
            <label>Кол-во мест *</label>
            <b-form-input
              class="modalInput"
              type="text"
              name="placeAmount2"
              v-model="modalInfo.provider[index].placeAmount"
              v-validate="'required'"
            ></b-form-input>
            <span
              v-show="errors.has('placeAmount2')"
              class="text-danger"
            >{{ errors.first('placeAmount2') }}</span>
          </b-form-group>
          <b-form-group>
            <label>Сумма</label>
            <b-form-input class="modalInput" v-model="modalInfo.provider[index].summ"></b-form-input>
          </b-form-group>
          <b-form-group>
            <label>Дата *</label>
            <datepicker
              :language="ru"
              v-model="modalInfo.provider[index].date"
              name="date2"
              v-validate="'required'"
            ></datepicker>
            <span v-show="errors.has('date2')" class="text-danger">{{ errors.first('date2') }}</span>
            <!-- <b-form-input class="modalInput" v-model="modalInfo.provider[index].date"></b-form-input> -->
          </b-form-group>
          <hr>
        </div>
        <b-button size="sm" @click="addFormEdit()">
          <i class="icon-plus"></i>
        </b-button>
        <b-button size="sm" @click="removeFormEdit()">
          <i class="icon-minus"></i>
        </b-button>
        <b-form-group>
          <label>Контрагент *</label>
          <!-- <b-form-select v-model="modalInfo.contrAgent._id" :options="clients" class="col-10" size="sm"/> -->
          <Multiselect
            name="contrAgent2"
            placeholder="Выберите"
            v-validate="'required'"
            v-model="modalInfo.contrAgent"
            :options="clients"
            track-by="_id"
            label="fullname"
          ></Multiselect>
          <span
            v-show="errors.has('contrAgent2')"
            class="text-danger"
          >{{ errors.first('contrAgent2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Номер</label>
          <b-form-input class="modalInput" name="modalInfo.number" v-model="modalInfo.number"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Дата *</label>
          <datepicker :language="ru" v-model="modalInfo.date" name="date2" v-validate="'required'"></datepicker>
          <span v-show="errors.has('date2')" class="text-danger">{{ errors.first('date2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Объем, м3</label>
          <b-form-input class="modalInput" name="modalInfo.volume" v-model="modalInfo.volume"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Вес, кг</label>
          <b-form-input class="modalInput" name="modalInfo.weight" v-model="modalInfo.weight"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Способ оплаты</label>
          <b-form-select
            v-model="modalInfo.payStatus"
            :options="payStatuses"
            class="col-10"
            size="sm"
          />
        </b-form-group>
        <b-btn class="mt-3" variant="primary" block @click="edit">Изменить</b-btn>
        <!-- <b-btn class="mt-3" variant="outline-danger" block @click="deleting(modalInfo._id)">Удалить</b-btn> -->
      </b-container>
      <div slot="modal-footer" class="w-100"></div>
    </b-modal>

    <b-modal id="modalEnded" title="Уведомление" centered>
      <b-container fluid>
        <b-form-group>
          <label>Нельзя редактировать, так как доставлен</label>
        </b-form-group>
      </b-container>
      <div slot="modal-footer" class="w-100"></div>
    </b-modal>
  </b-container>
</template>

<script>
import { ru } from "vuejs-datepicker/dist/locale";
import Api from "@/services/Api";
import Datepicker from "vuejs-datepicker";
import Multiselect from "vue-multiselect";

export default {
  components: {
    Datepicker,
    Multiselect
  },
  props: {
    caption: {
      type: String,
      default: "Заявки"
    },
    hover: {
      type: Boolean,
      default: true
    },
    striped: {
      type: Boolean,
      default: true
    },
    bordered: {
      type: Boolean,
      default: true
    },
    small: {
      type: Boolean,
      default: true
    }
  },
  data: () => {
    return {
      ru: ru,
      totalSumm: 0,
      totalCash: 0,
      totalOnlineCash: 0,
      totalPayedCash: 0,
      forms: 1,
      items: [],
      allItemsExcel: [],
      online: [],
      cash: [],
      payed: [],
      constItems: [],
      employees: [],
      clients: [],
      payStatuses: ["cash", "online", "payed"],
      jsonFields: {
        Номер: "number",
        "Передал (имя, кол-во мест, сумма)": "provider",
        "Дата и время": "date",
        Контрагент: "contrAgent",
        Телефон: "phone",
        "Кол-во мест": "placeAmount",
        "Способ оплаты": "payStatus",
        "Объем, м3": "volume",
        "Вес, кг": "weight",
        Сумма: "summ",
        Статус: "status",
        Статус: "payed"
      },
      fields: [
        { key: "number", sortable: true, label: "Номер" },
        {
          key: "provider",
          sortable: true,
          label: "Передал (имя, кол-во мест, сумма)"
        },
        { key: "date", sortable: true, label: "Дата и время" },
        { key: "contrAgent", sortable: true, label: "Контрагент" },
        { key: "phone", sortable: true, label: "Телефон" },
        { key: "placeAmount", sortable: true, label: "Кол-во мест" },
        { key: "payStatus", sortable: true, label: "Способ оплаты" },
        { key: "volume", sortable: true, label: "Объем, м3" },
        { key: "weight", sortable: true, label: "Вес, кг" },
        { key: "summ", sortable: true, label: "Сумма" },
        // { key: 'status', sortable: true, label: 'Статус' },
        { key: "payed", sortable: true, label: "Статус" },
        { key: "action", label: "Действия" }
      ],
      currentPage: 1,
      currentPage2: 1,
      currentPage3: 1,
      perPage: 10,
      totalRows: 0,
      filter: null,
      logisticInfo: {
        govNumber: "",
        date: "",
        employee: {
          name: "",
          lastName: "",
          phone: ""
        }
      },
      bids: [],
      bids_selected: [],
      addedInfo: {
        bid: []
      },
      modalInfo: {
        _id: "",
        provider: [{ id: [], placeAmount: "", summ: "", date: "" }],
        date: "",
        contrAgent: "",
        volume: "",
        weight: "",
        payStatus: ""
      },
      types: [
        { value: "number", text: "Номер" },
        { value: "provider", text: "Передал" },
        { value: "contrAgent", text: "Контрагент" }
      ],
      selected: {
        cash: [],
        online: [],
        payed: []
      }
    };
  },
  computed: {
    disabled() {
      if (this.addedInfo.bid.length > 0) {
        return false;
      } else {
        return true;
      }
    },
    birMassiv() {
      return [...this.items.onlineExcel, ...this.items.payedExcel, ...this.items.cashExcel]
    }
    
  },
  beforeMount() {
    this._beforeMount();
    this.getEmployees();
    this.getClients();
    this.getBids();
  },
  mounted() {
  },
  created() {
    
  },
  methods: {
    _beforeMount() {
      Api()
        .get("getRaceById/" + this.$route.params.id)
        .then(response => {
          this.logisticInfo = response.data.logistic;
          this.cash = response.data.cash;
          this.online = response.data.online;
          this.payed = response.data.payed;
          this.constItems.cash = response.data.cash;
          this.constItems.online = response.data.online;
          this.constItems.payed = response.data.payed;
          
          for (var i = 0; i < this.payStatuses.length; i++) {
            var name = this.payStatuses[i] + "Excel";
            this.items[name] = response.data[this.payStatuses[i]].map(item => {
              var providers = item.provider.reduce(function(all, pro) {
                return (
                  pro.id.name +
                  " " +
                  pro.id.lastName +
                  ", " +
                  pro.placeAmount +
                  ", " +
                  pro.summ +
                  "; " +
                  all
                );
              }, "");
              return {
                number: item.number.padStart(5, "0"),
                provider: providers,
                date: this.dateFormat(item.date),
                contrAgent:
                  item.contrAgent.lastName + " " + item.contrAgent.name,
                phone: item.contrAgent.phone,
                placeAmount: item.placeAmount,
                payStatus:
                  item.payStatus === "cash"
                    ? "Наличными"
                    : item.payStatus === "online"
                    ? "Онлайн"
                    : item.payStatus === "payed"
                    ? "Оплачено"
                    : "",
                volume: item.volume,
                weight: item.weight,
                summ: item.summ,
                //status: item.status === 'storage' ? 'На складе' : item.status === 'ship' ? 'В дороге' : item.status === 'done' ? 'Доставлено' : '',
                payed: item.payed === true ? "Доставлен" : "Не доставлен"
              };
            });
          } 

          let summ = 0;
          let totalCash = 0;
          let totalOnlineCash = 0;
          let totalPayedCash = 0;
          response.data.cash.forEach(function(item) {
            totalCash += item.summ;
          });
          response.data.online.forEach(function(item) {
            totalOnlineCash += item.summ;
          });
          response.data.payed.forEach(function(item) {
            totalPayedCash += item.summ;
          });
          this.totalCash = totalCash;
          this.totalOnlineCash = totalOnlineCash;
          this.totalPayedCash = totalPayedCash;
          this.totalSumm = totalCash + totalOnlineCash + totalPayedCash;
        });
    },
    async deleting(_id) {
      const answer = confirm(
        "Нажмите OK для продолжения или Cancel для выхода."
      );
      if (answer) {
        Api()
          .post("deletebidinlogistics", { bid: _id, id: this.$route.params.id })
          .then(response => {
            this.resetModal();
            window.location.reload();
          });
      } else {
        this.resetModal();
      }
    },
    adding() {
      Api()
        .post("addbidtologistics", {
          bid: this.addedInfo,
          id: this.$route.params.id
        })
        .then(response => {
          this.resetModal();
          window.location.reload();
        });
    },
    edit() {
      this.$validator.validateAll();
      if (this.validateEditing()) {
        this.modalInfo.discount = this.discountValue(this.modalInfo.discount);
        for (let i = 0; i < this.modalInfo.provider.length; i++) {
          this.modalInfo.provider[i].id = this.modalInfo.provider[i].id.id;
        }

        Api()
          .post("editbid", this.modalInfo)
          .then(response => {
            this.resetModal();
            window.location.reload();
          });
      }
    },
    discountValue(discount) {
      if (discount < 0) {
        discount = Math.abs(discount);
      }
      if (discount > 100) {
        discount = discount.slice(0, 2);
      }
      return discount;
    },
    addForm() {
      this.addedInfo.provider.push({
        id: "",
        placeAmount: "",
        summ: "",
        date: ""
      });
      this.forms++;
    },
    removeForm() {
      if (this.forms > 1) {
        this.addedInfo.provider.pop();
        this.forms--;
      }
    },
    getBids() {
      Api()
        .get("getactivebids", { status: "storage" })
        .then(response => {
          this.bids = response.data.docs.map(item => {
            return { value: item._id, text: item.number };
          });
        });
    },
    getEmployees() {
      Api()
        .post("getByParameters", { type: "provider" })
        .then(response => {
          this.employees = response.data.map(item => {
            return { id: item._id, fullname: item.lastName + " " + item.name };
          });
        });
    },
    getClients() {
      Api()
        .post("getByParameters", { type: "client" })
        .then(response => {
          this.clients = response.data.map(item => {
            return { _id: item._id, fullname: item.lastName + " " + item.name };
          });
        });
    },
    addFormEdit() {
      this.modalInfo.provider.push({
        id: "",
        placeAmount: "",
        summ: "",
        date: ""
      });
    },
    removeFormEdit() {
      if (this.modalInfo.provider.length > 1) {
        const answer = confirm("Вы уверены что хотите убрать представителя?");
        if (answer) {
          this.modalInfo.provider.pop();
        } else {
          this.resetModal();
        }
      }
    },
    dateFormat(_date) {
      function fmt(n) {
        return n > 9 ? n : "0" + n;
      }
      const now = new Date(_date.toString().trim());
      let time = "";
      if (now != "Invalid Date") {
        _date =
          fmt(now.getDate()) +
          "." +
          fmt(now.getMonth() + 1) +
          "." +
          fmt(now.getFullYear());
        time = fmt(now.getHours()) + ":" + fmt(now.getMinutes());
      }

      return _date + " " + time;
    },
    filterCustom(payType) {
      let text = this.selected[payType].text;
      let type = this.selected[payType].type;

      this[payType] = this.constItems[payType];

      this[payType] = this[payType].filter(function(item) {
        let reg = new RegExp(text, "i");
        if (
          (type == "number" && reg.test(item.number)) ||
          reg.test(item.number.padStart(5, "0"))
        ) {
          return item;
        } else if (type == "contrAgent" && item.contrAgent) {
          let name = item.contrAgent.name;
          let lastName = item.contrAgent.lastName;
          if (reg.test(name) || reg.test(lastName)) {
            return item;
          }
        } else if (type == "provider" && item.provider[0].id) {
          var isExists = false;
          for (var i = 0; i < item.provider.length; i++) {
            let name = item.provider[i].id.name;
            let lastName = item.provider[i].id.lastName;
            if (reg.test(name) || reg.test(lastName)) {
              isExists = true;
            }
          }
          if (isExists) {
            return item;
          }
        }
      });
    },
    getRowCount(items) {
      if (items) {
        return items.length;
      }
      return 0;
    },
    resetModal() {
      this.bids = [];
    },
    async openAddingModal() {
      this.$root.$emit("bv::show::modal", "addingModal");
    },
    validateEditing() {
      var countIfFilled = 0;
      var countProviders = this.modalInfo.provider.length;
      for (var i = 0; i < countProviders; i++) {
        if (
          this.modalInfo.provider[i].id &&
          this.modalInfo.provider[i].placeAmount &&
          this.modalInfo.provider[i].date
        ) {
          countIfFilled++;
        }
      }
      if (
        countIfFilled == countProviders &&
        this.modalInfo.contrAgent &&
        this.modalInfo.date
      ) {
        return true;
      } else {
        return false;
      }
    },
    info(_item) {
      const item = _item.provider;
      this.modalInfo = _item;
      this.modalInfo.contrAgent.fullname =
        _item.contrAgent.lastName + " " + _item.contrAgent.name;
      for (let i = 0; i < item.length; i++) {
        if (item[i].id != null) {
          let name = item[i].id.name;
          let lastName = item[i].id.lastName;
          this.modalInfo.provider[i].id.id = item[i].id._id;
          this.modalInfo.provider[i].id.fullname = lastName + " " + name;
          this.modalInfo.provider[i].name = name;
          this.modalInfo.provider[i].lastName = lastName;
        } else {
          this.modalInfo.provider[i] = {
            name: "",
            lastName: "",
            id: { id: "", fullname: "" }
          };
        }
      }

      if (_item.payed === true) {
        this.$root.$emit("bv::show::modal", "modalEnded");
      } else {
        this.$root.$emit("bv::show::modal", "modalInfo");
      }
    }
  }
};
</script>
